#!/usr/bin/python
# Copyright (C) 2003,2004 Panagiotis Issaris
# 
# BlenderX3DImporter is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published
# by the Free Software Foundation, Inc., 675 Mass Ave, Cambridge MA
# 02139, USA; either version 2 of the License, or (at your option)
# any later version.
#
# BlenderX3DImporter is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.

from xml.sax.handler import ContentHandler
from xml.sax import make_parser
import string
import sys

class X3DHandler(ContentHandler):
    ci = []
    
    def startElement(self, name, attrs):
        print name
        if name == "IndexedFaceSet":
            print "poly = NMesh.GetRaw()"
            ci_string = attrs["coordIndex"]
            self.ci = string.split(ci_string," ")

        elif name == "Coordinate":
            points_string = attrs["point"]
            points = string.split(points_string," ")
            for i in range(len(points)/3):
                print "v = NMesh.Vert(%f,%f,%f)" % (float(points[i*3]),float(points[i*3+1]),float(points[i*3+2]))
                print "poly.verts.append(v)"
        
    def endElement(self,name):
        print "~",name
        if name == "IndexedFaceSet":
            for i in range(len(self.ci)/3):
                print "f = NMesh.Face()"
                print "f .v.append(poly.verts[%d])" % int(self.ci[i*3])
                print "f .v.append(poly.verts[%d])" % int(self.ci[i*3+1])
                print "f .v.append(poly.verts[%d])" % int(self.ci[i*3+2])
                print "poly.faces.append(f)"
            print "polyObj = NMesh.PutRaw(poly)"
                

    def characters(self, chars):
        print chars

def load_x3d(filename):
	x3d = X3DHandler()

	saxparser = make_parser()
	saxparser.setContentHandler(x3d)
	datasource = open(filename,"r")
	saxparser.parse(datasource)
	return 1

